/* pc.c - terminal I/O calls for GNU info for OS/2
   and other PC support functions
   Kai Uwe Rommel, 1990-1993
 */

#include <stdio.h>
#include <stdlib.h>

#include <io.h>
#include <fcntl.h>
#include <string.h>

#define INCL_VIO
#include <os2emx.h>
#include <sys/kbdscan.h>

#include "pc.h"

static VIOCURSORINFO vci;

void pc_init (void)
{
  VIOCURSORINFO vcin;
  VioGetCurType(&vci, 0);
  vcin = vci;
  vcin.yStart = 0;
  vcin.cEnd = -100;
  VioSetCurType(&vcin, 0);
}

void pc_exit (void)
{
  VioSetCurType(&vci, 0);
}

int pc_getc (void)
{
  int c;

  c = _read_kbd (0, 1, 0);

  if (c != 0x00 && c != 0xE0)
    return (c == 8 || c == 26) ? 127 : c;
  else
    switch (c = _read_kbd (0, 1, 0))
      {
      case K_F1:
        return '?';

      case K_RIGHT:
        return 'n';
      case K_LEFT:
        return 'p';

      case K_HOME:
	return 'b';
      case K_END:
        return 'e';

      case K_CTRL_HOME:
        return 'd';
      case K_CTRL_DOWN:
        return 'f';
      case K_CTRL_UP:
        return 'u';

      case K_DOWN:
        return 'N'-64;
      case K_UP:
        return 'P'-64;

      case K_DEL:
      case K_PAGEUP:
	return 0177;
      case K_PAGEDOWN:
        return ' ';

      default:
	return ' ';
      }
}
